﻿package 
{
	import ascb.util.NumberUtilities;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFieldType;
	import gs.easing.Expo;
	import gs.TweenLite;
	import nl.rackdoll.konami.KCI;
	
	/**
	 * ...
	 * @author ...
	 */
	public class Main extends Sprite 
	{
		private var _RACKDOLLCODE:String = 'LLLUUURRRbbaa';
		public function Main():void 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private var k:KCI;
		private var sp:Sprite    = new Sprite();
		private var tf:TextField = new TextField();
		private var tfTitle:TextField = new TextField();
		private var tfExpl:TextField = new TextField();
		private var button:Sprite = new Sprite;
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			// entry point
			
			
			sp.graphics.beginFill( 0xDEADBEAF );
			sp.graphics.drawCircle( 0, 0, 25 );
			addChild( sp );
			sp.y = stage.stageHeight >> 1;
			sp.x = stage.stageWidth >> 1;
			
			
			tf.multiline = true;
			tf.wordWrap = true;
			tf.width = 300;
			tf.autoSize = TextFieldAutoSize.LEFT;
			tf.text = "--- KONAMI CODE INTERPRETER v1.0 ---\nup ,up ,down ,down ,left ,right ,left ,right ,b ,a" + KCI.supportedCodes();
			//tf.y = -25;
			tf.selectable = false;
			addChild( tf );
			
			tfTitle.autoSize = TextFieldAutoSize.LEFT;
			tfTitle.text = "Submit your own code here and test it out!";
			tfTitle.x = stage.stageWidth - tfTitle.textWidth  -10;
			tfTitle.y = 0;
			addChild( tfTitle );
			tfExpl.background =  true;
			tfExpl.wordWrap = false;
			tfExpl.multiline = false;
			tfExpl.height = 20;
			tfExpl.width = 200;
			tfExpl.type = TextFieldType.INPUT;
			tfExpl.x = stage.stageWidth - tfExpl.width;
			tfExpl.y = 20;
			addChild( tfExpl );
			
			button.graphics.beginFill( 0, 1 );
			button.graphics.drawRect( 0, 0, 70, 25 );
			button.x = (stage.stageWidth - button.width) - 55;
			button.y = 50;
			button.alpha = .4
			button.buttonMode = true;
			button.addEventListener(MouseEvent.MOUSE_OVER, onOver );
			button.addEventListener(MouseEvent.MOUSE_OUT, onOut );
			button.addEventListener(MouseEvent.CLICK, onSubmitCode );
			addChild( button );
			
			k = new KCI(stage);
			k.addEventListener( KCI._KONAMI_CODE, onCode );
			
			KCI.help();
		}
		private function onOver( e:MouseEvent ):void {
			button.alpha = 1;
		}
		private function onOut( e:MouseEvent ):void {
			button.alpha = .4;
		}
		private function onSubmitCode( e:MouseEvent ):void {
			//k.removeCode( tfExpl.text );
			k.addCode( tfExpl.text );
			k.addEventListener( tfExpl.text, onCode );
			tfExpl.text = "Code has been submitted!";
		}
		
		private function onCode(e:Event ):void {
			TweenLite.to( sp, 2, { x: NumberUtilities.random( 0, stage.stageWidth ),  y: NumberUtilities.random( 0, stage.stageHeight ), ease:Expo.easeOut } );
		}
		
	}
	
}